/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <sys/types.h>

#include <gtk/gtk.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

////

// includes

//#include <termios.h>
//#include <stdio.h>
//#include <unistd.h>
//#include <fcntl.h>
//#include <sys/signal.h>
//#include <sys/types.h>

// prototypes

gint timeout_callback(gpointer data);
gboolean delete_event(GtkWidget *widget, GdkEvent *event, gpointer data);
void cell_edited_callback(GtkCellRendererText *cell, gchar *path_string, gchar *new_text,gpointer user_data);

void rfidConnectReader(void);
void signal_handler_IO (int status);
void rfidGetTagID(char *select, char *tagID);
char *rfidGetTagTypeName(char *select);
char *rfidGetTagManufacturerName(char *select);
void rfidReadLine(char *result);
void rfidReadPage(char *pageNo, char *page);
void rfidReset();

void updateGUI(int adr, gchar *new_text);

// RFID Definitions

#define RFID_CMD_RESET "x"
#define RFID_CMD_VERSION "v"
#define RFID_CMD_SELECT "s"
#define RFID_CMD_READ_PAGE "r"
#define RFID_CMD_WRITE_PAGE "w"

#define RFID_ERR_UNKNOWN_CMD '?'
#define RFID_ERR_GENERAL_FAILURE 'F'
#define RFID_ERR_INVALID_DATA 'I'
#define RFID_ERR_NO_TAG 'N'
#define RFID_ERR_WRITE_FAILURE 'U'
#define RFID_ERR_PAGE_LOCKED 'L'

#define RFID_MSG_UNKNOWN_CMD "Unknown Command"
#define RFID_MSG_GENERAL_FAILURE "General Failure"
#define RFID_MSG_INVALID_DATA "Invalid Data"
#define RFID_MSG_NO_TAG "No Tag"
#define RFID_MSG_WRITE_FAILURE "Write Failure"
#define RFID_MSG_PAGE_LOCKED "Lock Failure"

#define RFID_TAG_TYPE_ISO15693 'V'
#define RFID_TAG_TYPE_TAGIT 'T'
#define RFID_TAG_TYPE_ICODE 'I'
#define RFID_TAG_TYPE_MIFARE 'M'
#define RFID_TAG_TYPE_SR176 'S'
#define RFID_TAG_TYPE_ISO1443B 'Z'

#define RFID_TAG_NAME_ISO15693 "ISO 15693"
#define RFID_TAG_NAME_TAGIT "Tagit"
#define RFID_TAG_NAME_ICODE "Icode"
#define RFID_TAG_NAME_MIFARE "Mifare (ISO 14443 Type A)"
#define RFID_TAG_NAME_SR176 "SR176"
#define RFID_TAG_NAME_ISO1443B "ISO 14443 Type B"

#define RFID_TAG_MFR_STMICROELECTRONICS "ST Microelectronics"
#define RFID_TAG_MFR_PHILLIPS "Phillips Semiconductors"
#define RFID_TAG_MFR_INFINEON "Infinion Technologies AG"
#define RFID_TAG_MFR_TEXASINSTRUMENTS "Texas Instruments"
#define RFID_TAG_MFR_EMMICROELECTRONICS "EM Microelectronic-Marin SA"

#define RFID_BLANK ""
#define RFID_COOKIE_ID "DEADFACE"

static int RFID_PAGE_LENGTH = 4;

// configuration information for ACG reader

#define BAUDRATE B9600
#define DATABITS CS8
#define STOPBITS 0
#define PARITYON 0
#define PARITY 0

#define _POSIX_SOURCE 1 //POSIX compliant source

char devicename[] = "/dev/ttyS1";
int fd;
struct termios oldtio, newtio;       //place for old and new port settings for serial port
struct sigaction saio;               //definition of signal action

int USE_COOKIES = TRUE;

static GtkWidget *entryTagID;
static GtkWidget *entryManufacturer;
static GtkWidget *entryTagType;
static GtkWidget *entryValue;
static GtkWidget *entryCounter;
static GtkWidget *cbActive;
static GtkWidget *treeview1;

static GtkTreeModel *model;

enum
{
    COL_ADR = 0,
    COL_0,
    COL_1,
    COL_2,
    COL_3,
    COL_4,
    COL_5,
    COL_6,
    COL_7,
    COL_ASCII,
    NUM_COLS
};
////

int main (int argc, char *argv[])
{
  GtkWidget *windowRFDump;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

  windowRFDump = create_windowRFDump ();
  gtk_widget_show (windowRFDump);

  ////
  treeview1 = lookup_widget(GTK_WIDGET(windowRFDump), "treeview1");

  entryTagID = lookup_widget(GTK_WIDGET(windowRFDump), "entryTagID");
  entryTagType = lookup_widget(GTK_WIDGET(windowRFDump), "entryTagType");
  entryManufacturer = lookup_widget(GTK_WIDGET(windowRFDump), "entryManufacturer");
  entryValue = lookup_widget(GTK_WIDGET(windowRFDump), "entryValue");
  entryCounter = lookup_widget(GTK_WIDGET(windowRFDump), "entryCounter");
  cbActive = lookup_widget(GTK_WIDGET(windowRFDump), "cbActive");

  g_signal_connect(G_OBJECT(windowRFDump), "delete_event", G_CALLBACK(delete_event), NULL);
  g_timeout_add (1000, timeout_callback, (gpointer)"workThread");

  printf("\n\nRFDump V1.2\n\n");
  printf("Copyright 2004 by Boris Wolf and Lukas Grunwald\n");
  printf("For more information see www.rfdump.org\n\n");

  if (argc == 2)
  {
    strcpy(devicename, argv[1]);
  } else {
    printf("usage: rfdump [tty]\n\n");
  }

  rfidConnectReader();
  rfidReset();

  // create list view and model

  GtkListStore *liststore;
  GtkTreeIter   iter;

  liststore = gtk_list_store_new(NUM_COLS, 
        G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,G_TYPE_STRING,
        G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,G_TYPE_STRING);

  GtkTreeViewColumn   *col;
  GtkCellRenderer     *renderer;

  /* --- Column #1 (Adr) --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "Adr");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(treeview1), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);

  g_object_set_data(G_OBJECT(renderer), "my_column_num", GUINT_TO_POINTER(COL_ADR));

  gtk_tree_view_column_add_attribute(col, renderer, "text", COL_ADR);

  g_signal_connect(renderer, "edited", (GCallback)cell_edited_callback, liststore);

  /* --- Columns #2 - #9 --- */

  int colNo = 0;

  char headers[][8] = {"0 / 8", "1 / 9", "2 / A", "3 / B", "4 / C", "5 / D", "6 / E", "7 / F"};

  for (colNo=1; colNo<=8; colNo++) {

    col = gtk_tree_view_column_new();

    gtk_tree_view_column_set_title(col, &(headers[colNo-1][0]));

    /* pack tree view column into tree view */
    gtk_tree_view_append_column(GTK_TREE_VIEW(treeview1), col);

    renderer = gtk_cell_renderer_text_new();

    /* pack cell renderer into tree view column */
    gtk_tree_view_column_pack_start(col, renderer, TRUE);

    /* set 'cell-background' property of the cell renderer */
    g_object_set(renderer,
               "cell-background", "Orange",
               "cell-background-set", TRUE,
               NULL);

    g_object_set(renderer, "editable", TRUE, NULL);

    g_object_set_data(G_OBJECT(renderer), "my_column_num", GUINT_TO_POINTER(colNo));

    gtk_tree_view_column_add_attribute(col, renderer, "text", colNo);

    g_signal_connect(renderer, "edited", (GCallback)cell_edited_callback, liststore);
  }

  /* --- Column #10 (ASCII) --- */

  col = gtk_tree_view_column_new();

  gtk_tree_view_column_set_title(col, "ASCII");

  /* pack tree view column into tree view */
  gtk_tree_view_append_column(GTK_TREE_VIEW(treeview1), col);

  renderer = gtk_cell_renderer_text_new();

  /* pack cell renderer into tree view column */
  gtk_tree_view_column_pack_start(col, renderer, TRUE);

  g_object_set(renderer, "editable", TRUE, NULL);
  g_object_set(renderer, "family", "Monospace", NULL);

  g_object_set_data(G_OBJECT(renderer), "my_column_num", GUINT_TO_POINTER(COL_ASCII));
 
  gtk_tree_view_column_add_attribute(col, renderer, "text", COL_ASCII);

  g_signal_connect(renderer, "edited", (GCallback)cell_edited_callback, liststore);

  model = GTK_TREE_MODEL(liststore);
  gtk_tree_view_set_model(GTK_TREE_VIEW(treeview1), GTK_TREE_MODEL(liststore));

  g_object_unref(liststore);

  /* Now the model will be destroyed when the tree view is destroyed */

  gtk_entry_set_text(entryValue, RFID_COOKIE_ID);
  ////

  gtk_main();
  return 0;
}

////
void updateGUI(int adr, gchar *new_text) {
  
  int row_number = (int)adr/8;
  int column_number = (adr%8)+1;

  char *path_string[255];
  sprintf(path_string, "%d", row_number);

  GtkTreePath *path = gtk_tree_path_new_from_string(path_string);

  GtkTreeIter iter;  
  gtk_tree_model_get_iter(model, &iter, path);
  gtk_list_store_set(model, &iter, column_number, new_text, -1);

  // update ASCII

  gchar *ascii;
  gtk_tree_model_get (model, &iter, COL_ASCII, &ascii, -1);

  int i;

  for (i=0; i<strlen(new_text)/2; i++)
  {
    int asciiCode = getCharValue(new_text[2*i])*16 + getCharValue(new_text[2*i+1]);

//    if (asciiCode>=0x20)
      if ((asciiCode>=(int)'A' && asciiCode<=(int)'Z') ||
          (asciiCode>=(int)'a' && asciiCode<=(int)'z') ||
          (asciiCode>=(int)'0' && asciiCode<=(int)'9')) 
      ascii[((column_number-1)*(strlen(new_text)/2))+i] = (char)asciiCode;
    else 
      ascii[((column_number-1)*(strlen(new_text)/2))+i] = '.';
  }

  gtk_list_store_set(model, &iter, COL_ASCII, ascii, -1);
}

void cell_edited_callback (GtkCellRendererText *cell, gchar *path_string, gchar *new_text, 
  gpointer user_data) {

  printf("CELL EDITED:%s\n", new_text);

  // get column

  guint column_number = GPOINTER_TO_UINT(g_object_get_data(G_OBJECT(cell), "my_column_num"));
  printf("COLUMN:%d\n", column_number);

  // do padding / cropping for ascii field if necessary

  if (column_number == 9) {

    if (strlen(new_text)>8*RFID_PAGE_LENGTH)
    {
      new_text[8*RFID_PAGE_LENGTH] = '\0';
    } else if ((strlen(new_text)<8*RFID_PAGE_LENGTH)) {
      int i;

      gchar *tmp_new_text = malloc((8*RFID_PAGE_LENGTH)+1);
      strcpy(tmp_new_text, new_text);

      for (i=0; i<(8*RFID_PAGE_LENGTH)-strlen(new_text); i++)
      {
        strcat(tmp_new_text,".");
      }

      new_text = tmp_new_text;
    }

  } else if (column_number>=1 && column_number<=8) {

    if (strlen(new_text)>2*RFID_PAGE_LENGTH)
    {
      new_text[2*RFID_PAGE_LENGTH] = '\0';
    } else if ((strlen(new_text)<2*RFID_PAGE_LENGTH)) {
      int i;

      gchar *tmp_new_text = malloc((2*RFID_PAGE_LENGTH)+1);
      strcpy(tmp_new_text, new_text);

      for (i=0; i<(2*RFID_PAGE_LENGTH)-strlen(new_text); i++)
      {
        strcat(tmp_new_text,"0");
      }

      new_text = tmp_new_text;
    }
  }

  GtkTreePath *path = gtk_tree_path_new_from_string(path_string);

  // get row

  gint *indices = gtk_tree_path_get_indices(path);
  int row_number = indices[0];
  printf("ROW:%d\n", row_number);

  GtkTreeIter iter;  
  gtk_tree_model_get_iter(model, &iter, path);

  // update model

  gtk_list_store_set (model, &iter, column_number, new_text, -1);

  // write RFID chip

  // hex editor

  if (column_number>=1 && column_number<=8) {

    int intAdr = row_number*8 + column_number-1;    
    char hexAdr[3];

    if (intAdr<16) 
      sprintf(hexAdr,"0%x",intAdr);
    else
      sprintf(hexAdr,"%x",intAdr);

    rfidWritePage(hexAdr, new_text);

    // update ASCII

    gchar *ascii;
    gtk_tree_model_get (model, &iter, COL_ASCII, &ascii, -1);

    int i;

    for (i=0; i<strlen(new_text)/2; i++)
    {
      int asciiCode = getCharValue(new_text[2*i])*16 + getCharValue(new_text[2*i+1]);

//      if (asciiCode>=0x20)
      if ((asciiCode>=(int)'A' && asciiCode<=(int)'Z') ||
          (asciiCode>=(int)'a' && asciiCode<=(int)'z') ||
          (asciiCode>=(int)'0' && asciiCode<=(int)'9')) 
        ascii[((column_number-1)*(strlen(new_text)/2))+i] = (char)asciiCode;
      else 
        ascii[((column_number-1)*(strlen(new_text)/2))+i] = '.';
    }

    gtk_list_store_set(model, &iter, COL_ASCII, ascii, -1);

  // ascii editor

  } else if (column_number==9) {

    int i;
    char page[17];
    char pageByte[3];
    char pageAdr[3];
    int hexCol = 1;

    page[0] = '\0';

    for (i=0; i<strlen(new_text); i++) {

      if ((int)new_text[i]<16)
        sprintf(pageByte, "0%X", (int)new_text[i]);
      else       
        sprintf(pageByte, "%X", (int)new_text[i]);

      strcat(page, pageByte);

      if ((i+1)%RFID_PAGE_LENGTH == 0) {

        int adr = (row_number*8)+(int)(i/RFID_PAGE_LENGTH);

        if (adr<16)
          sprintf(pageAdr, "0%x", adr);
        else       
          sprintf(pageAdr, "%x", adr);

        gchar *hexValue = malloc(sizeof(page)+1);
        strcpy(hexValue, page);

        rfidWritePage(pageAdr, page);
        page[0] = '\0';

        // update hex

        printf("NEW VALUE:%s\n", hexValue);
        
        gtk_list_store_set(model, &iter, hexCol, hexValue, -1);
        hexCol++;
      }
    }
  }
}

gboolean delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {

    gtk_main_quit();
    return FALSE;
}

gint timeout_callback(gpointer data) {

  static char line[255];
  static char tagID[255];
  static char newTagID[255];
  static char page[255];
  static char pageNo[255];

  static int nothing_in_field = FALSE;
  static int maxAdr=0;

  printf("TIMER WRITING: %s\n", RFID_CMD_SELECT);
  write(fd, RFID_CMD_SELECT, 1); //write select command to card reader
  rfidReadLine(line);
  printf("LINE: %s\n", line);
  //printf("WRITE...\n");

  if (strlen(line)>1) {

    rfidGetTagID(line, newTagID);

    if (strcmp(newTagID, tagID)) {

      maxAdr = 0;

      strcpy(tagID,newTagID);

      gtk_entry_set_text((GtkEntry*)entryTagID, tagID);
      gtk_entry_set_text((GtkEntry*)entryTagType, rfidGetTagTypeName(line));
      gtk_entry_set_text((GtkEntry*)entryManufacturer, rfidGetTagManufacturerName(line));

      //read memory

      printf("READING MEMORY");

      gtk_list_store_clear(model);

      char *row[10];
      int i, k, adr = 0;

      for (k=0; k<32; k++) {

        row[0] = malloc(sizeof("00")+1);
        sprintf(row[0],"%X",(int)k*8/16);

        //row[9] = malloc(sizeof("")+1);
        //strcpy(row[9], "");

        row[9] = malloc(255+1);
        *(row[9]) = '\0';

        for (i=0; i<8; i++) {

          adr = k*8+i;

          if (adr<16) 
            sprintf(pageNo,"0%x",adr);
          else
            sprintf(pageNo,"%x",adr);

          rfidReadPage(pageNo, page);
   
          putc('.', stdout);

          if (k==0 && i==0)
            RFID_PAGE_LENGTH = strlen(page)/2;

          //printf("%s:%s\n", pageNo, page);
  
          if (strlen(page)>1) {
            row[i+1] = malloc(sizeof(page)+1);
            strcpy(row[i+1], page);
            strcat(row[9], page);
          } else {
            row[i+1] = malloc(sizeof("--------")+1);
            strcpy(row[i+1], "--------");
            if (maxAdr == 0)
              maxAdr = adr-1;
          }
        }

        for (i=0; i<strlen(row[9])/2; i++) {

          int asciiCode = getCharValue(row[9][2*i])*16 + getCharValue(row[9][2*i+1]);

//          if (asciiCode>=0x20)
          if ((asciiCode>=(int)'A' && asciiCode<=(int)'Z') ||
              (asciiCode>=(int)'a' && asciiCode<=(int)'z') ||
              (asciiCode>=(int)'0' && asciiCode<=(int)'9')) 
            row[9][i] = (char)asciiCode;
          else 
            row[9][i] = '.';
        }

        row[9][i] = '\0';

        GtkTreeIter iter;

        /* Append an empty row to the list store. Iter will point to the new row */
        gtk_list_store_append(model, &iter);

        /* Fill fields with some data */
        gtk_list_store_set (model, &iter, 0, row[0], 1, row[1], 2, row[2], 3, row[3], 4, row[4], 5, row[5], 
          6, row[6], 7, row[7], 8, row[8], 9, row[9], -1);

        //if (strlen(page) == 1) 
        //  break;
      }
    }

    printf("\n");

    if (nothing_in_field)
    {
      // COOKIES

      nothing_in_field = FALSE;

      if (gtk_toggle_button_get_active(cbActive))
      {
        if (maxAdr-2<16) 
          sprintf(pageNo,"0%x",maxAdr-2);
        else
          sprintf(pageNo,"%x",maxAdr-2);

        rfidReadPage(pageNo, page);

        gchar *cookieID = gtk_entry_get_text(entryValue);

        int i;

        for (i=0; i<strlen(cookieID); i++)
        {
          cookieID[i] = toupper(cookieID[i]);
        }

        gtk_entry_set_text(entryValue, cookieID);

        if (!strcmp(page, cookieID)) {

          printf("COOKIE FOUND\n");

          // read counter

          if (maxAdr-1<16) 
            sprintf(pageNo,"0%x",maxAdr-1);
          else
            sprintf(pageNo,"%x",maxAdr-1);

          rfidReadPage(pageNo, page);

          // increment counter

          int counter = 0;
          sscanf(page,"%d",&counter);
          counter++;
          sprintf(page,"%08d",counter);

          // write counter

          rfidWritePage(pageNo, page);
          updateGUI(maxAdr-1, page);
          gtk_entry_set_text(entryCounter, page);

        } else {

          printf("NO COOKIE FOUND\n");

          // initialize cookie

          rfidWritePage(pageNo, cookieID);          
          updateGUI(maxAdr-2, cookieID);

          if (maxAdr-1<16) 
            sprintf(pageNo,"0%x",maxAdr-1);
          else
            sprintf(pageNo,"%x",maxAdr-1);

          rfidWritePage(pageNo, "00000000");          
          updateGUI(maxAdr-1, "00000000");
        }
      }
    }

  } else {
    nothing_in_field = TRUE;
  }

  printf("DONE\n");
}

int getCharValue(char c) {
 
  switch (c) {
    case '0' : return 0;
    case '1' : return 1;
    case '2' : return 2;
    case '3' : return 3;
    case '4' : return 4;
    case '5' : return 5;
    case '6' : return 6;
    case '7' : return 7;
    case '8' : return 8;
    case '9' : return 9;
    case 'A' : return 10;
    case 'B' : return 11;
    case 'C' : return 12;
    case 'D' : return 13;
    case 'E' : return 14;
    case 'F' : return 15;
  }
}

void rfidConnectReader(void) {

   // open the device (com port) to be non-blocking (read will return immediately)

   fd = open(devicename, O_RDWR | O_NOCTTY | O_NONBLOCK);

   if (fd < 0)
   {
      perror(devicename);
      exit(-1);
   }

   // install the serial handler before making the device asynchronous

   //saio.sa_handler = signal_handler_IO;
   //sigemptyset(&saio.sa_mask); //saio.sa_mask = 0;
   //saio.sa_flags = 0;
   //saio.sa_restorer = NULL;
   //sigaction(SIGIO,&saio,NULL);

   // allow the process to receive SIGIO

   //fcntl(fd, F_SETOWN, getpid());

   // Make the file descriptor asynchronous (the manual page says only
   // O_APPEND and O_NONBLOCK, will work with F_SETFL...)

   //fcntl(fd, F_SETFL, FASYNC);

   tcgetattr(fd,&oldtio); //save current port settings 

   // set new port settings for canonical input processing 

   newtio.c_cflag = BAUDRATE | CRTSCTS | DATABITS | STOPBITS | PARITYON | PARITY | CLOCAL | CREAD;
   newtio.c_iflag = IGNPAR;
   newtio.c_oflag = 0;
   newtio.c_lflag = 0; //ICANON;
   newtio.c_cc[VMIN]=1;
   newtio.c_cc[VTIME]=0;
   tcflush(fd, TCIFLUSH);
   tcsetattr(fd,TCSANOW,&newtio);
}

void rfidReadLine(char *result) {

  char inputChar;
  char buf[255];
  int pos = 0;
  int numRead = 0;
//  char *result;
  int finished = FALSE;

  buf[0] = '\0';

  do
  {
    numRead = read(fd,&inputChar,1);

    if (numRead == 1) 
    {
      buf[pos] = inputChar;
      pos++;
      buf[pos] = '\0';

      if ((int)buf[pos-1] == 0x0A && (int)buf[pos-2] == 0x0D) {
        buf[pos-2] = '\0';
        finished = TRUE;
      }
    }

  } while (!finished);

  //result = malloc(sizeof(buf)+2);
  strcpy(result, buf);
  //return result;
}

void rfidReadPage(char *pageNo, char *page) {

  char rfidCmd[255];
  rfidCmd[0] = '\0';

  strcat(rfidCmd, RFID_CMD_READ_PAGE);
  strcat(rfidCmd, pageNo);

  write(fd, rfidCmd, strlen(rfidCmd)); //write command to card reader

  rfidReadLine(page);
}

void rfidWritePage(char *pageNo, char *page) {

  char rfidCmd[255];
  rfidCmd[0] = '\0';

  strcat(rfidCmd, RFID_CMD_WRITE_PAGE);
  strcat(rfidCmd, pageNo);
  strcat(rfidCmd, page);

  printf("WRITE:%s\n", rfidCmd);

  write(fd, rfidCmd, strlen(rfidCmd)); //write command to card reader
  rfidReadLine(rfidCmd); //read response
}

void rfidReset() {

  char rfidCmd[255];
  rfidCmd[0] = '\0';

  strcat(rfidCmd, RFID_CMD_RESET);

  printf("WRITE:%s\n", rfidCmd);

  write(fd, rfidCmd, strlen(rfidCmd)); //write command to card reader
  rfidReadLine(rfidCmd); //read response
}

/**************************************************************************
* Signal handler                                                          *
*                                                                         *
* Called when data availabe on card reader.                               *
***************************************************************************/

void signal_handler_IO (int status)
{
  printf("RUNNING IO HANDLER\n");
}

/**************************************************************************
* RFID Functions                                                          *
*                                                                         *
*                                                                         *
***************************************************************************/

void rfidGetTagID(char *select, char *tagID) {
   strcpy(tagID, select+1);
}

char* rfidGetTagTypeName(char *select) {

   char *tagType = RFID_BLANK;

   if (select != NULL) {

      switch (*select) {

         case RFID_TAG_TYPE_ISO15693 :
            tagType = RFID_TAG_NAME_ISO15693;
            break;
         case RFID_TAG_TYPE_TAGIT :
            tagType = RFID_TAG_NAME_TAGIT;
            break;
         case RFID_TAG_TYPE_ICODE :
            tagType = RFID_TAG_NAME_ICODE;
            break;
         case RFID_TAG_TYPE_MIFARE :
            tagType = RFID_TAG_NAME_MIFARE;
            break;
         case RFID_TAG_TYPE_SR176 :
            tagType = RFID_TAG_NAME_SR176;
            break;
         case RFID_TAG_TYPE_ISO1443B :
            tagType = RFID_TAG_NAME_ISO1443B;
            break;
      }
   }

   return tagType;
}

char *rfidGetTagManufacturerName(char *select) {

   char *tagManufacturer = RFID_BLANK;

   if (select != NULL) {
      if (strlen(select) > 1) {

         if (*select == RFID_TAG_TYPE_ISO15693) {

            if (select[3] == '0' && select[4] == '2')
               tagManufacturer = RFID_TAG_MFR_STMICROELECTRONICS;
            else if (select[3] == '0' && select[4] == '4')
               tagManufacturer = RFID_TAG_MFR_PHILLIPS;
            else if (select[3] == '0' && select[4] == '5')
               tagManufacturer = RFID_TAG_MFR_INFINEON;
            else if (select[3] == '0' && select[4] == '7')
               tagManufacturer = RFID_TAG_MFR_TEXASINSTRUMENTS;
            else if (select[3] == '1' && select[4] == '6')
               tagManufacturer = RFID_TAG_MFR_EMMICROELECTRONICS;

         } else if (*select == RFID_TAG_TYPE_TAGIT) {
            tagManufacturer = RFID_TAG_MFR_TEXASINSTRUMENTS;
         } else if (*select == RFID_TAG_TYPE_ICODE) {
            tagManufacturer = RFID_TAG_MFR_PHILLIPS;
         } else if (*select == RFID_TAG_TYPE_SR176) {
            tagManufacturer = RFID_TAG_MFR_STMICROELECTRONICS;
         }
      }
   }

   return tagManufacturer;
}
////

